=== debian/changelog ===
rust-coreutils (0.5.0-0ubuntu2) resolute; urgency=medium

  * Add and install l10n translation files.

 -- Simon Johnsson <simon.johnsson@canonical.com>  Fri, 30 Jan 2026 14:33:41 +0100

rust-coreutils (0.5.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (LP: #2138304)
  * Change applied patches:
    - Tweak-release-build-profile: Remove panic = "abort"
      in Cargo.toml as it is already set by default.
    - workspace-exclude: Remove tests/benches as it no
      longer exists upstream.
  * Skip failing 0.5.0 tests (LP: #2138377)
  * Enable passing 0.5.0 tests

 -- Simon Johnsson <simon.johnsson@canonical.com>  Mon, 12 Jan 2026 15:23:49 +0100
