=== debian/watch ===
Version: 5

Template: GitHub
Dist: https://github.com/uutils/coreutils

Template: GitHub
Component: l10n
Dist: https://github.com/uutils/coreutils-l10n
