=== debian/changelog ===
rust-coreutils (0.6.0-1) unstable; urgency=medium

  * New upstream release
  * Vendor dependencies. Too hard to maintain in Debian
  * Update lintian override info format in d/source/lintian-overrides

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Feb 2026 13:48:51 +0100

rust-coreutils (0.0.30-4) unstable; urgency=medium

  * Team upload.

  [ Jeremy Bícha]
  * remove unused Build-Depends: librust-unix-socket-dev

  [ Peter Michael Green ]
  * Add patch for nix 0.30

 -- Peter Michael Green <plugwash@debian.org>  Tue, 30 Sep 2025 12:45:34 +0000

rust-coreutils (0.0.30-3) unstable; urgency=medium

  * Team upload.
  * Bump the notify dependency to v8

 -- NoisyCoil <noisycoil@debian.org>  Wed, 24 Sep 2025 19:38:04 +0200

rust-coreutils (0.0.30-3~exp1) experimental; urgency=medium

  * Also ship with b3sum (Closes: #1107092)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 02 Jun 2025 20:43:15 +0200
